%if 0%{?fedora}
# https://bugzilla.redhat.com/show_bug.cgi?id=995136#c12
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif
%global provider        github
%global provider_tld    com
%global project         prometheus
%global repo            prometheus
%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}
%global commit          43b41c56ce469cdaa94447541693578c5ec16a91
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        0.13.3
Release:        3%{?dist}
Summary:        The Prometheus monitoring system and time series database
License:        ASL 2.0
URL:            https://%{import_path}
Source0:        https://%{import_path}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
Patch0:         hack-makefile.patch

%description
%{summary}

%package -n %{repo}
Summary:        %{summary}
ExclusiveArch:  %{ix86} x86_64 %{arm}

BuildRequires: golang >= 1.2.1-3
BuildRequires: golang(github.com/golang/glog)
BuildRequires: golang(github.com/golang/protobuf/proto)
BuildRequires: golang(github.com/miekg/dns)
BuildRequires: golang(github.com/prometheus/client_golang/model)
BuildRequires: golang(github.com/prometheus/client_golang/prometheus)
BuildRequires: golang(github.com/prometheus/client_golang/extraction)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb/filter)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb/iterator)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb/opt)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb/util)
BuildRequires: golang(golang.org/x/net/context)

Provides: prometheus = %{version}-%{release}

%description -n %{repo}
%{summary}

%if 0%{?fedora}
%package devel
Summary:        %{summary}

BuildRequires: golang >= 1.2.1-3
BuildRequires: golang(github.com/golang/glog)
BuildRequires: golang(github.com/golang/protobuf/proto)
BuildRequires: golang(github.com/miekg/dns)
BuildRequires: golang(github.com/prometheus/client_golang/model)
BuildRequires: golang(github.com/prometheus/client_golang/prometheus)
BuildRequires: golang(github.com/prometheus/client_golang/extraction)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb/filter)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb/iterator)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb/opt)
BuildRequires: golang(github.com/syndtr/goleveldb/leveldb/util)
BuildRequires: golang(golang.org/x/net/context)

Requires: golang >= 1.2.1-3
Requires: golang(github.com/golang/glog)
Requires: golang(github.com/golang/protobuf/proto)
Requires: golang(github.com/miekg/dns)
Requires: golang(github.com/prometheus/client_golang/model)
Requires: golang(github.com/prometheus/client_golang/prometheus)
Requires: golang(github.com/prometheus/client_golang/extraction)
Requires: golang(github.com/syndtr/goleveldb/leveldb)
Requires: golang(github.com/syndtr/goleveldb/leveldb/filter)
Requires: golang(github.com/syndtr/goleveldb/leveldb/iterator)
Requires: golang(github.com/syndtr/goleveldb/leveldb/opt)
Requires: golang(github.com/syndtr/goleveldb/leveldb/util)
Requires: golang(golang.org/x/net/context)

Provides: golang(%{import_path}/config) = %{version}-%{release}
Provides: golang(%{import_path}/config/generated) = %{version}-%{release}
Provides: golang(%{import_path}/notification) = %{version}-%{release}
Provides: golang(%{import_path}/promql) = %{version}-%{release}
Provides: golang(%{import_path}/retrieval) = %{version}-%{release}
Provides: golang(%{import_path}/rules) = %{version}-%{release}
Provides: golang(%{import_path}/stats) = %{version}-%{release}
Provides: golang(%{import_path}/storage) = %{version}-%{release}
Provides: golang(%{import_path}/storage/local) = %{version}-%{release}
Provides: golang(%{import_path}/storage/local/codable) = %{version}-%{release}
Provides: golang(%{import_path}/storage/local/flock) = %{version}-%{release}
Provides: golang(%{import_path}/storage/local/index) = %{version}-%{release}
Provides: golang(%{import_path}/storage/metric) = %{version}-%{release}
Provides: golang(%{import_path}/storage/remote) = %{version}-%{release}
Provides: golang(%{import_path}/storage/remote/influxdb) = %{version}-%{release}
Provides: golang(%{import_path}/storage/remote/opentsdb) = %{version}-%{release}
Provides: golang(%{import_path}/templates) = %{version}-%{release}
Provides: golang(%{import_path}/utility) = %{version}-%{release}
Provides: golang(%{import_path}/utility/test) = %{version}-%{release}
Provides: golang(%{import_path}/web) = %{version}-%{release}
Provides: golang(%{import_path}/web/api) = %{version}-%{release}
Provides: golang(%{import_path}/web/blob) = %{version}-%{release}
Provides: golang(%{import_path}/web/httputils) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for 
building other packages which use %{project}/%{repo}.

%endif

%prep
%setup -q -n %{repo}-%{commit}
%patch0 -p1

%build
# set working directory
mkdir -p src/github.com/prometheus
ln -s ../../../ src/github.com/prometheus/prometheus

# set environment variables
export GO_VERSION=$(go version | cut -d' ' -f3 | sed 's/go//')
%if 0%{?fedora}
export GOPATH=$(pwd):%{gopath}
%else
# build from bundled dependencies
cp -r Godeps/_workspace/src/* src/.
export GOPATH=$(pwd)
%endif
export TMPDIR=/tmp
export GOROOT=/usr/lib/golang
export BUILDDATE=$(date +%Y%m%d-%H:%M:%S)

# generate blob/files.go
make -C web

# build prometheus
go build -v -x -o bin/prometheus -a -ldflags "-B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \n') -X main.buildVersion %{version} -X main.buildRevision %{shortcommit} -X main.buildBranch master -X main.buildUser fedora -X main.buildDate ${BUILDDATE} -X main.goVersion ${GO_VERSION}" .

%install
install -D -p -m 0755 bin/%{repo} %{buildroot}%{_bindir}/%{repo}

%if 0%{?fedora}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
cp -pav *.go %{buildroot}/%{gopath}/src/%{import_path}/

cp -rpav web %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav utility %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav templates %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav storage %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav stats %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav rules %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav retrieval %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav promql %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav notification %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav config %{buildroot}/%{gopath}/src/%{import_path}/

pushd %{buildroot}/%{gopath}/src/%{import_path}
rm -rf $(find . -iname .gitignore)
popd

rm -rf utility/embed-static.sh

%check
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/web/api
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/utility
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/templates
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/storage/remote
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/storage/remote/opentsdb
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/storage/remote/influxdb
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/storage/metric
#GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/storage/local
#GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/storage/local/flock
#GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/storage/local/codable
#GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/rules
#GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/promql
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/retrieval
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/notification
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/config

%files devel
%doc AUTHORS.md CHANGELOG.md CONTRIBUTING.md README.md LICENSE
%doc Godeps/Godeps.json
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%{gopath}/src/%{import_path}

%endif

%files -n %{repo}
%doc AUTHORS.md CHANGELOG.md CONTRIBUTING.md README.md LICENSE
%doc Godeps/Godeps.json
%{_bindir}/%{repo}

%changelog
* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.13.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed May 13 2015 jchaloup <jchaloup@redhat.com> - 0.13.3-2
- Add debug info
  related: #1190426

* Tue May 12 2015 jchaloup <jchaloup@redhat.com> - 0.13.3-1
- Update to 0.13.3
  related: #1190426

* Sat May 09 2015 jchaloup <jchaloup@redhat.com> - 0.13.2-1
- Update to 0.13.2
  related: #1190426

* Sat Feb 07 2015 jchaloup <jchaloup@redhat.com> - 0-0.1.git4e6a807
- First package for Fedora
  resolves: #1190426
